#
# Calamari Spec File
#

%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

#################################################################################
# common
#################################################################################
Name:		calamari-server
Summary:	Manage and monitor Ceph with a REST API
Group:		System/Filesystems
BuildRequires:	postgresql-devel
BuildRequires:	python-setuptools
BuildRequires:	python-virtualenv
BuildRequires:	redhat-lsb-core
Requires:	httpd
Requires:	mod_wsgi
Requires:	cairo
Requires:	pycairo
Requires:	logrotate
Requires:	supervisor
Requires:	salt-master
Requires:	salt-minion
Requires:	postgresql
Requires:	postgresql-libs
Requires:	postgresql-server
Version: 	1.2.3
Release: 	13%{?dist}
License: 	LGPL-2.1+
URL:		http://ceph.com/
Source0:	%{name}_%{version}.tar.gz
# Source1 is a git snapshot of python-flake8
Source1:	422dc5e.tar.gz
Provides:	bundled(python-flake8)
Source2:	alembic-0.6.3.tar.gz
Provides:	bundled(python-alembic) = 0.6.3
Source3:	apache-libcloud-0.16.0.tar.bz2
Provides:	bundled(python-apache-libcloud) = 0.16.0
Source4:	argparse-1.2.1.tar.gz
Provides:	bundled(python-argparse) = 1.2.1
Source5:	argparse-1.3.0.tar.gz
Provides:	bundled(python-argparse) = 1.3.0
Source6:	carbon-0.9.13.tar.gz
Provides:	bundled(carbon) = 0.9.13
Source7:	ceph-graphite-web-0.9.11-57-g6f23d36.tar.gz
Provides:	bundled(python-graphite-web) = 0.9.11
Source8:	configobj-5.0.6.tar.gz
Provides:	bundled(python-configobj) = 5.0.6
Source9:	coverage-3.6.zip
Provides:	bundled(python-coverage) = 3.6
Source10:	Cython-0.19.2.tar.gz
Provides:	bundled(Cython) = 0.19.2
Source11:	diamond-3.4.421.tar.gz
Provides:	bundled(diamond) = 3.4.421
Source12:	distribute-0.7.3.zip
Provides:	bundled(python-distribute) = 0.7.3
Source13:	Django-1.5.1.tar.gz
Provides:	bundled(Django) = 1.5.1
Source14:	django-filter-0.6.tar.gz
Provides:	bundled(python-django-filter) = 0.6
Source15:	django-jsonfield-0.9.10.tar.gz
Provides:	bundled(python-django-jsonfield) = 0.9.10
Source16:	django-nose-1.2.tar.gz
Provides:	bundled(python-django-nose) = 1.2
Source17:	djangorestframework-2.3.12.tar.gz
Provides:	bundled(python-djangorestframework) = 2.3.12
Source18:	django-tagging-0.3.1.tar.gz
Provides:	bundled(django-tagging) = 0.3.1
Source19:	docutils-0.12.tar.gz
Provides:	bundled(python-docutils) = 0.12
Source20:	gevent-1.0.1.tar.gz
Provides:	bundled(python-gevent) = 1.0.1
Source21:	graphite-project-whisper-0.9.11-pre1-56-ga6e2176.tar.gz
Provides:	bundled(graphite-project-whisper) = 0.9.10
Source22:	greenlet-0.4.5.zip
Provides:	bundled(python-greenlet) = 0.4.5
Source23:	importlib-1.0.1.tar.bz2
Provides:	bundled(python-importlib) = 1.0.1
Source24:	Jinja2-2.7.3.tar.gz
Provides:	bundled(python-jinja2) = 2.7.3
Source25:	M2Crypto-0.22.3.tar.gz
Provides:	bundled(python-mcrypto) = 0.22.3
Source26:	Mako-1.0.1.tar.gz
Provides:	bundled(python-mako) = 1.0.1
Source27:	manhole-0.6.0.tar.gz
Provides:	bundled(python-manhole) = 0.6.0
Source28:	Markdown-2.3.1.tar.gz
Provides:	bundled(python-markdown) = 2.3.1
Source29:	MarkupSafe-0.23.tar.gz
Provides:	bundled(python-markupsafe) = 0.23
Source30:	mccabe-0.3.tar.gz
Provides:	bundled(python-mccabe) = 0.3
Source31:	meld3-1.0.0.tar.gz
Provides:	bundled(python-meld3) = 1.0.0
Source32:	mock-1.0.1.tar.gz
Provides:	bundled(python-mock) = 1.0.1
Source33:	msgpack-python-0.4.5.tar.gz
Provides:	bundled(python-msgpack) = 0.4.5
Source34:	nose-1.3.0.tar.gz
Provides:	bundled(python-nose) = 1.3.0
Source35:	pep8-1.5.7.tar.gz
Provides:	bundled(python-pep8) = 1.5.7
Source36:	psutil-2.0.0.tar.gz
Provides:	bundled(python-psutil) = 2.0.0
Source37:	psycogreen-1.0.tar.gz
Provides:	bundled(python-psycogreen) = 1.0
Source38:	psycopg2-2.5.2.tar.gz
Provides:	bundled(python-psycopg2) = 2.5.2
Source39:	pycrypto-2.6.1.tar.gz
Provides:	bundled(python-pycrypto) = 2.6.1
Source40:	pyflakes-0.8.1.tar.gz
Provides:	bundled(python-pyflakes) = 0.8.1
Source41:	Pygments-2.0.2.tar.gz
Provides:	bundled(python-pygments) = 2.0.2
Source42:	python-dateutil-2.2.tar.gz
Provides:	bundled(python-dateutil) = 2.2
Source43:	pytz-2013.8.tar.bz2
Provides:	bundled(pytz) = 2013.8
Source44:	PyYAML-3.11.tar.gz
Provides:	bundled(PyYAML) = 3.11
Source45:	pyzmq-14.2.0.tar.gz
Provides:	bundled(pyzmq) = 14.2.0
Source46:	requests-1.2.3.tar.gz
Provides:	bundled(python-requests) = 1.2.3
Source47:	salt-2014.1.0-stripped.tar.gz
Provides:	bundled(salt) = 2014.1.0
Source48:	setuptools-12.0.5-stripped.tar.gz
Provides:	bundled(python-setuptools) = 12.0.5
Source49:	six-1.9.0.tar.gz
Provides:	bundled(python-six) = 1.9.0
Source50:	Sphinx-1.1.3.tar.gz
Provides:	bundled(python-sphinx) = 1.9.0
Source51:	SQLAlchemy-0.8.3.tar.gz
Provides:	bundled(python-sqlalchemy) = 0.8.3
Source52:	supervisor-3.1.3.tar.gz
Provides:	bundled(python-supervisor) = 3.1.3
Source53:	Twisted-11.1.0.tar.bz2
Provides:	bundled(python-twisted) = 11.1.0
Source54:	Twisted-15.0.0.tar.bz2
Provides:	bundled(python-twisted) = 15.0.0
Source55:	txAMQP-0.6.2.tar.gz
Provides:	bundled(python-txamqp) = 0.6.2
Source56:	whisper-0.9.10.zip
Provides:	bundled(python-whisper) = 0.9.10
Source57:	wsgiref-0.1.2.zip
Provides:	bundled(python-wsgiref) = 0.1.2
Source58:	zerorpc-0.4.4.tar.gz
Provides:	bundled(python-zerorpc) = 0.4.4
Source59:	zope.interface-4.1.2.tar.gz
Provides:	bundled(python-zope-interface) = 4.1.2
Patch0:		0001-RHEL-7-compile-patch.patch
# Patch1 is upstream as 99aa40d36f452487993545efae0001f692467b2b
# See https://bugzilla.redhat.com/1190766
Patch1:		0002-salt-test-for-RHEL-7.x-rather-than-RHEL-7.0.patch
Patch2:		0003-ceph-module-backport-admin-socket-pattern-matching.patch

%prep
%setup -T -b 0 -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

mkdir -p pkgs
cp -p %SOURCE1 pkgs/
cp -p %SOURCE2 pkgs/
cp -p %SOURCE3 pkgs/
cp -p %SOURCE4 pkgs/
cp -p %SOURCE5 pkgs/
cp -p %SOURCE6 pkgs/
cp -p %SOURCE7 pkgs/
cp -p %SOURCE8 pkgs/
cp -p %SOURCE9 pkgs/
cp -p %SOURCE10 pkgs/
cp -p %SOURCE11 pkgs/
cp -p %SOURCE12 pkgs/
cp -p %SOURCE13 pkgs/
cp -p %SOURCE14 pkgs/
cp -p %SOURCE15 pkgs/
cp -p %SOURCE16 pkgs/
cp -p %SOURCE17 pkgs/
cp -p %SOURCE18 pkgs/
cp -p %SOURCE19 pkgs/
cp -p %SOURCE20 pkgs/
cp -p %SOURCE21 pkgs/
cp -p %SOURCE22 pkgs/
cp -p %SOURCE23 pkgs/
cp -p %SOURCE24 pkgs/
cp -p %SOURCE25 pkgs/
cp -p %SOURCE26 pkgs/
cp -p %SOURCE27 pkgs/
cp -p %SOURCE28 pkgs/
cp -p %SOURCE29 pkgs/
cp -p %SOURCE30 pkgs/
cp -p %SOURCE31 pkgs/
cp -p %SOURCE32 pkgs/
cp -p %SOURCE33 pkgs/
cp -p %SOURCE34 pkgs/
cp -p %SOURCE35 pkgs/
cp -p %SOURCE36 pkgs/
cp -p %SOURCE37 pkgs/
cp -p %SOURCE38 pkgs/
cp -p %SOURCE39 pkgs/
cp -p %SOURCE40 pkgs/
cp -p %SOURCE41 pkgs/
cp -p %SOURCE42 pkgs/
cp -p %SOURCE43 pkgs/
cp -p %SOURCE44 pkgs/
cp -p %SOURCE45 pkgs/
cp -p %SOURCE46 pkgs/
cp -p %SOURCE47 pkgs/salt-2014.1.0.tar.gz
cp -p %SOURCE48 pkgs/setuptools-12.0.5.tar.gz
cp -p %SOURCE49 pkgs/
cp -p %SOURCE50 pkgs/
cp -p %SOURCE51 pkgs/
cp -p %SOURCE52 pkgs/
cp -p %SOURCE53 pkgs/
cp -p %SOURCE54 pkgs/
cp -p %SOURCE55 pkgs/
cp -p %SOURCE56 pkgs/
cp -p %SOURCE57 pkgs/
cp -p %SOURCE58 pkgs/
cp -p %SOURCE59 pkgs/

%install
make VERSION=%{version} REVISION=0 DESTDIR=${RPM_BUILD_ROOT} install-rpm
chmod -R go-w ${RPM_BUILD_ROOT}/opt/calamari/venv/lib/python2.6/site-packages/setuptools-0.9.8-py2.6.egg-info
chmod -R go-w ${RPM_BUILD_ROOT}/opt/calamari/venv/lib/python2.6/site-packages/wsgiref-0.1.2-py2.6.egg-info

%description -n calamari-server
Calamari is a webapp to monitor and control a Ceph cluster via a web
browser. 

%files -n calamari-server
/opt/calamari/
%{_sysconfdir}/salt/master.d/calamari.conf
%{_sysconfdir}/graphite/
%{_sysconfdir}/supervisor/conf.d/calamari.conf
%{_sysconfdir}/logrotate.d/calamari
%{_sysconfdir}/httpd/conf.d/calamari.conf
%{_sysconfdir}/calamari/
/usr/bin/calamari-ctl
%dir %attr (755, apache, apache) /var/log/calamari
%dir %attr (755, apache, apache) /var/log/graphite
%dir /var/lib/calamari
%dir /var/lib/cthulhu
%dir /var/lib/graphite
%dir /var/lib/graphite/log
%dir /var/lib/graphite/log/webapp
%dir /var/lib/graphite/whisper

%post -n calamari-server
calamari_httpd()
{
	d=$(pwd)

	# allow apache access to all
	chown -R apache.apache /opt/calamari/webapp/calamari

	# apache shouldn't need to write, but it does because
	# graphite creates index on read
	chown -R apache.apache /var/lib/graphite

	# centos64
	mv /etc/httpd/conf.d/welcome.conf /etc/httpd/conf.d/welcome.conf.orig
        chown -R apache:apache /var/log/calamari
	cd $d

	# Load our salt config
	service salt-master restart

	# concatenate our config chunk with supervisord.conf
	echo "### START calamari-server ###" >> /etc/supervisord.conf
	cat /etc/supervisor/conf.d/calamari.conf >> /etc/supervisord.conf
	echo "### END calamari-server ###" >> /etc/supervisord.conf

	# Load our supervisor config
	service supervisord stop
	sleep 3
	service supervisord start
}

calamari_httpd
service httpd stop || true
service httpd start

# Prompt the user to proceed with the final script-driven
# part of the installation process
echo "Thank you for installing Calamari."
echo ""
echo "Please run 'calamari-ctl initialize' as root to complete the installation."
exit 0

%preun -n calamari-server
if [ $1 == 0 ] ; then 
	rm /etc/httpd/conf.d/calamari.conf
	rm /etc/httpd/conf.d/wsgi.conf
	mv /etc/httpd/conf.d/welcome.conf.orig /etc/httpd/conf.d/welcome.conf
	service httpd stop || true
	service httpd start || true
	service supervisord stop
	sed -i '/^### START calamari-server/,/^### END calamari-server/d' /etc/supervisord.conf
	service supervisord start
fi
exit 0

%postun -n calamari-server
# Remove anything left behind in the calamari and graphite
# virtual environment  directories, if this is a "last-instance" call
if [ $1 == 0 ] ; then
	rm -rf /opt/graphite
	rm -rf /opt/calamari
	rm -rf /var/log/graphite
	rm -rf /var/log/calamari
	rm -rf /var/lib/graphite/whisper
fi
exit 0

%changelog
* Fri Apr 10 2015 Gregory Meno <gmeno@redhat.com> - 1.2.3-13
- fixed bug in backported code for socket pattern matching BZ#1209859

* Fri Apr 10 2015 Gregory Meno <gmeno@redhat.com> - 1.2.3-12
- ceph module: backport admin socket pattern matching BZ#1209859

* Tue Mar 3 2015 Boris Ranto <branto@redhat.com> - 1.2.3-11
- Strip sources of binary executables

* Wed Feb 18 2015 Boris Ranto <branto@redhat.com> - 1.2.3-10
- Skipped -9 since it was built with reverted commits
- Removed diamond from Requires

* Wed Feb 11 2015 Ken Dreyer <kdreyer@redhat.com> - 1.2.3-8
- Remove RHEL "7.0" hardcoding (RHBZ #1190766)

* Tue Feb 03 2015 Ken Dreyer <kdreyer@redhat.com> - 1.2.3-7
- Remove Inktank references
- Add virtual Provides for bundled libs

* Tue Feb 3 2015 Boris Ranto <branto@redhat.com> - 1.2.3-6
- do not package world-writable files v2
- el6 also packaged wsgi in a world-writable manner

* Tue Feb 3 2015 Boris Ranto <branto@redhat.com> - 1.2.3-5
- do not package world-writable files

* Fri Jan 30 2015 Boris Ranto <branto@redhat.com> - 1.2.3-4
- update sources file to not track old version of the tarball
- rework dependencies, they are different for rhel 6

* Fri Jan 30 2015 Boris Ranto <branto@redhat.com> - 1.2.3-3
- use correct git-tag tarball as a base

* Thu Jan 29 2015 Boris Ranto <branto@redhat.com> - 1.2.3-2
- use tagged tarball as a base

* Wed Jan 28 2015 Boris Ranto <branto@redhat.com> - 1.2.3-1
- Initial version
